## qemu-kvm 1.2.0+noroms

=== Makefile ===
# Makefile for QEMU.

# Always point to the root of the build tree (needs GNU make).
BUILD_DIR=$(CURDIR)

# All following code might depend on configuration variables
ifneq ($(wildcard config-host.mak),)
# Put the all: rule here so that config-host.mak can contain dependencies.
all:
include config-host.mak
include $(SRC_PATH)/rules.mak
config-host.mak: $(SRC_PATH)/configure
	@echo $@ is out-of-date, running configure
	@sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
else
config-host.mak:
	@echo "Please call configure before running make!"
	@exit 1
endif

GENERATED_HEADERS = config-host.h trace.h qemu-options.def
ifeq ($(TRACE_BACKEND),dtrace)
GENERATED_HEADERS += trace-dtrace.h
endif
GENERATED_HEADERS += qmp-commands.h qapi-types.h qapi-visit.h
GENERATED_SOURCES += qmp-marshal.c qapi-types.c qapi-visit.c trace.c

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

.PHONY: all clean cscope distclean dvi html info install install-doc \
	pdf recurse-all speed test dist

$(call set-vpath, $(SRC_PATH))

LIBS+=-lz $(LIBS_TOOLS)

HELPERS-$(CONFIG_LINUX) = qemu-bridge-helper$(EXESUF)

ifdef BUILD_DOCS
DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
ifdef CONFIG_VIRTFS
DOCS+=fsdev/virtfs-proxy-helper.1
endif
else
DOCS=
endif

SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory) BUILD_DIR=$(BUILD_DIR)
SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))

config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
	$(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@,"  GEN   $@")

-include $(SUBDIR_DEVICES_MAK_DEP)

%/config-devices.mak: default-configs/%.mak
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, "  GEN   $@")
	@if test -f $@; then \
	  if cmp -s $@.old $@; then \
	    mv $@.tmp $@; \
	    cp -p $@ $@.old; \
	  else \
	    if test -f $@.old; then \
	      echo "WARNING: $@ (user modified) out of date.";\
	    else \
	      echo "WARNING: $@ out of date.";\
	    fi; \
	    echo "Run \"make defconfig\" to regenerate."; \
	    rm $@.tmp; \
	  fi; \
	 else \
	  mv $@.tmp $@; \
	  cp -p $@ $@.old; \
	 fi

defconfig:
	rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)

-include config-all-devices.mak

all: $(DOCS) $(TOOLS) $(HELPERS-y) recurse-all

config-host.h: config-host.h-timestamp
config-host.h-timestamp: config-host.mak
qemu-options.def: $(SRC_PATH)/qemu-options.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))

subdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/Makefile.objs
endif

subdir-libcacard: $(oslib-obj-y) $(trace-obj-y) qemu-timer-common.o

$(filter %-softmmu,$(SUBDIR_RULES)): $(universal-obj-y) $(trace-obj-y) $(common-obj-y) $(extra-obj-y) subdir-libdis

$(filter %-user,$(SUBDIR_RULES)): $(universal-obj-y) $(trace-obj-y) subdir-libdis-user subdir-libuser

ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
romsubdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)

ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))

recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)

audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)

QEMU_CFLAGS+=$(CURL_CFLAGS)

QEMU_CFLAGS += -I$(SRC_PATH)/include

ui/cocoa.o: ui/cocoa.m

ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o hw/baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)

ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)

bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)

version.o: $(SRC_PATH)/version.rc config-host.h
	$(call quiet-command,$(WINDRES) -I. -o $@ $<,"  RC    $(TARGET_DIR)$@")

version-obj-$(CONFIG_WIN32) += version.o
######################################################################
# Support building shared library libcacard

.PHONY: libcacard.la install-libcacard
ifeq ($(LIBTOOL),)
libcacard.la:
	@echo "libtool is missing, please install and rerun configure"; exit 1

install-libcacard:
	@echo "libtool is missing, please install and rerun configure"; exit 1
else
libcacard.la: $(oslib-obj-y) qemu-timer-common.o $(addsuffix .lo, $(basename $(trace-obj-y)))
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" libcacard.la,)

install-libcacard: libcacard.la
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" install-libcacard,)
endif

######################################################################

qemu-img.o: qemu-img-cmds.h

tools-obj-y = $(oslib-obj-y) $(trace-obj-y) qemu-tool.o qemu-timer.o \
	qemu-timer-common.o main-loop.o notify.o \
	iohandler.o cutils.o iov.o async.o
tools-obj-$(CONFIG_POSIX) += compatfd.o

qemu-img$(EXESUF): qemu-img.o $(tools-obj-y) $(block-obj-y)
qemu-nbd$(EXESUF): qemu-nbd.o $(tools-obj-y) $(block-obj-y)
qemu-io$(EXESUF): qemu-io.o cmd.o $(tools-obj-y) $(block-obj-y)

qemu-bridge-helper$(EXESUF): qemu-bridge-helper.o

vscclient$(EXESUF): $(libcacard-y) $(oslib-obj-y) $(trace-obj-y) $(tools-obj-y) qemu-timer-common.o libcacard/vscclient.o
	$(call quiet-command,$(CC) $(LDFLAGS) -o $@ $^ $(libcacard_libs) $(LIBS),"  LINK  $@")

fsdev/virtfs-proxy-helper$(EXESUF): fsdev/virtfs-proxy-helper.o fsdev/virtio-9p-marshal.o oslib-posix.o $(trace-obj-y)
fsdev/virtfs-proxy-helper$(EXESUF): LIBS += -lcap

qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

qemu-ga$(EXESUF): LIBS = $(LIBS_QGA)
qemu-ga$(EXESUF): QEMU_CFLAGS += -I qga/qapi-generated

gen-out-type = $(subst .,-,$(suffix $@))

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/tests/Makefile
endif

qapi-py = $(SRC_PATH)/scripts/qapi.py $(SRC_PATH)/scripts/ordereddict.py

qga/qapi-generated/qga-qapi-types.c qga/qapi-generated/qga-qapi-types.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-types.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o qga/qapi-generated -p "qga-" < $<, "  GEN   $@")
qga/qapi-generated/qga-qapi-visit.c qga/qapi-generated/qga-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-visit.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o qga/qapi-generated -p "qga-" < $<, "  GEN   $@")
qga/qapi-generated/qga-qmp-commands.h qga/qapi-generated/qga-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-commands.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o qga/qapi-generated -p "qga-" < $<, "  GEN   $@")

qapi-types.c qapi-types.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-types.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "." < $<, "  GEN   $@")
qapi-visit.c qapi-visit.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-visit.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "."  < $<, "  GEN   $@")
qmp-commands.h qmp-marshal.c :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-commands.py $(qapi-py)
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -m -o "." < $<, "  GEN   $@")

QGALIB_GEN=$(addprefix qga/qapi-generated/, qga-qapi-types.h qga-qapi-visit.h qga-qmp-commands.h)
$(qga-obj-y) qemu-ga.o: $(QGALIB_GEN)

qemu-ga$(EXESUF): qemu-ga.o $(qga-obj-y) $(tools-obj-y) $(qapi-obj-y) $(qobject-obj-y) $(version-obj-y)

QEMULIBS=libhw32 libhw64 libuser libdis libdis-user

clean:
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	rm -f qemu-options.def
	find . -name '*.[od]' -exec rm -f {} +
	rm -f *.a *.lo $(TOOLS) $(HELPERS-y) qemu-ga TAGS cscope.* *.pod *~ */*~
	rm -Rf .libs
	rm -f qemu-img-cmds.h
	rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
	@# May not be present in GENERATED_HEADERS
	rm -f trace-dtrace.h trace-dtrace.h-timestamp
	rm -f $(foreach f,$(GENERATED_HEADERS),$(f) $(f)-timestamp)
	rm -f $(foreach f,$(GENERATED_SOURCES),$(f) $(f)-timestamp)
	rm -rf qapi-generated
	rm -rf qga/qapi-generated
	$(MAKE) -C tests/tcg clean
	for d in $(ALL_SUBDIRS) $(QEMULIBS) libcacard; do \
	if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
	rm -f $$d/qemu-options.def; \
        done

VERSION ?= $(shell cat VERSION)

dist: qemu-$(VERSION).tar.bz2

qemu-%.tar.bz2:
	$(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"

distclean: clean
	rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
	rm -f config-all-devices.mak
	rm -f roms/seabios/config.mak roms/vgabios/config.mak
	rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.cps qemu-doc.dvi
	rm -f qemu-doc.fn qemu-doc.fns qemu-doc.info qemu-doc.ky qemu-doc.kys
	rm -f qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp
	rm -f qemu-doc.vr
	rm -f config.log
	rm -f linux-headers/asm
	rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
	for d in $(TARGET_DIRS) $(QEMULIBS); do \
	rm -rf $$d || exit 1 ; \
        done

KEYMAPS=da     en-gb  et  fr     fr-ch  is  lt  modifiers  no  pt-br  sv \
ar      de     en-us  fi  fr-be  hr     it  lv  nl         pl  ru     th \
common  de-ch  es     fo  fr-ca  hu     ja  mk  nl-be      pt  sl     tr \
bepo

ifdef INSTALL_BLOBS
BLOBS=bios.bin sgabios.bin vgabios.bin vgabios-cirrus.bin \
vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
pxe-e1000.rom pxe-eepro100.rom pxe-ne2k_pci.rom \
pxe-pcnet.rom pxe-rtl8139.rom pxe-virtio.rom \
qemu-icon.bmp \
bamboo.dtb petalogix-s3adsp1800.dtb petalogix-ml605.dtb \
multiboot.bin linuxboot.bin kvmvapic.bin \
s390-zipl.rom \
spapr-rtas.bin slof.bin \
palcode-clipper
else
BLOBS=
endif

install-doc: $(DOCS)
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_docdir)"
	$(INSTALL_DATA) qemu-doc.html  qemu-tech.html "$(DESTDIR)$(qemu_docdir)"
	$(INSTALL_DATA) QMP/qmp-commands.txt "$(DESTDIR)$(qemu_docdir)"
ifdef CONFIG_POSIX
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
	$(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
endif
ifdef CONFIG_VIRTFS
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) fsdev/virtfs-proxy-helper.1 "$(DESTDIR)$(mandir)/man1"
endif

install-datadir:
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_datadir)"

install-confdir:
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_confdir)"

install-sysconfig: install-datadir install-confdir
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(qemu_confdir)"
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/cpus-x86_64.conf "$(DESTDIR)$(qemu_datadir)"

install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig install-datadir
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
ifneq ($(TOOLS),)
	$(INSTALL_PROG) $(STRIP_OPT) $(TOOLS) "$(DESTDIR)$(bindir)"
endif
ifneq ($(HELPERS-y),)
	$(INSTALL_DIR) "$(DESTDIR)$(libexecdir)"
	$(INSTALL_PROG) $(STRIP_OPT) $(HELPERS-y) "$(DESTDIR)$(libexecdir)"
endif
ifneq ($(BLOBS),)
	set -e; for x in $(BLOBS); do \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(qemu_datadir)"; \
	done
endif
	$(INSTALL_DIR) "$(DESTDIR)$(qemu_datadir)/keymaps"
	set -e; for x in $(KEYMAPS); do \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/keymaps/$$x "$(DESTDIR)$(qemu_datadir)/keymaps"; \
	done
	for d in $(TARGET_DIRS); do \
	$(MAKE) -C $$d $@ || exit 1 ; \
        done

# various test targets
test speed: all
	$(MAKE) -C tests/tcg $@

.PHONY: TAGS
TAGS:

=== libcacard/Makefile ===
-include ../config-host.mak
-include $(SRC_PATH)/Makefile.objs
-include $(SRC_PATH)/rules.mak

libcacard_includedir=$(includedir)/cacard

$(call set-vpath, $(SRC_PATH))

# objects linked into a shared library, built with libtool with -fPIC if required
QEMU_OBJS=$(oslib-obj-y) qemu-timer-common.o $(trace-obj-y)
QEMU_OBJS_LIB=$(patsubst %.o,%.lo,$(QEMU_OBJS))

QEMU_CFLAGS+=-I../

libcacard.lib-y=$(patsubst %.o,%.lo,$(libcacard-y))

clean:
	rm -f *.o */*.o *.d */*.d *.a */*.a *~ */*~ vscclient *.lo */*.lo .libs/* */.libs/* *.la */*.la *.pc
	rm -Rf .libs */.libs

all: libcacard.la libcacard.pc
# Dummy command so that make thinks it has done something
	@true

#########################################################################
# Rules for building libcacard standalone library

ifeq ($(LIBTOOL),)
libcacard.la:
	@echo "libtool is missing, please install and rerun configure"; exit 1

install-libcacard:
	@echo "libtool is missing, please install and rerun configure"; exit 1
else
libcacard.la: $(libcacard.lib-y) $(QEMU_OBJS_LIB)
	$(call quiet-command,$(LIBTOOL) --mode=link --quiet --tag=CC $(CC) -rpath $(libdir) -o $@ $^ $(libcacard_libs),"  lt LINK $@")

libcacard_srcpath=$(SRC_PATH)/libcacard
libcacard.pc: $(libcacard_srcpath)/libcacard.pc.in
	$(call quiet-command,sed -e 's|@LIBDIR@|$(libdir)|' \
		-e 's|@INCLUDEDIR@|$(libcacard_includedir)|' \
	    -e 's|@VERSION@|$(shell cat $(SRC_PATH)/VERSION)|' \
		-e 's|@PREFIX@|$(prefix)|' \
		< $(libcacard_srcpath)/libcacard.pc.in > libcacard.pc,\
	"  GEN   $@")

.PHONY: install-libcacard

install-libcacard: libcacard.pc libcacard.la vscclient
	$(INSTALL_DIR) "$(DESTDIR)$(libdir)"
	$(INSTALL_DIR) "$(DESTDIR)$(libdir)/pkgconfig"
	$(INSTALL_DIR) "$(DESTDIR)$(libcacard_includedir)"
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
	$(LIBTOOL) --mode=install $(INSTALL_PROG) vscclient "$(DESTDIR)$(bindir)"
	$(LIBTOOL) --mode=install $(INSTALL_DATA) libcacard.la "$(DESTDIR)$(libdir)"
	$(LIBTOOL) --mode=install $(INSTALL_DATA) libcacard.pc "$(DESTDIR)$(libdir)/pkgconfig"
	for inc in *.h; do \
		$(LIBTOOL) --mode=install $(INSTALL_DATA) $(libcacard_srcpath)/$$inc "$(DESTDIR)$(libcacard_includedir)"; \
	done
endif

=== roms/Makefile ===

vgabios_variants := stdvga cirrus vmware qxl

default:
	@echo "nothing is build by default"
	@echo "available build targets:"
	@echo "  bios           -- update bios.bin (seabios)"
	@echo "  seavgabios     -- update vgabios binaries (seabios)"
	@echo "  lgplvgabios    -- update vgabios binaries (lgpl)"

bios: config.seabios
	sh configure-seabios.sh $<
	make -C seabios out/bios.bin
	cp seabios/out/bios.bin ../pc-bios/bios.bin

seavgabios: $(patsubst %,seavgabios-%,$(vgabios_variants))

seavgabios-%: config.vga.%
	sh configure-seabios.sh $<
	make -C seabios out/vgabios.bin
	cp seabios/out/vgabios.bin ../pc-bios/vgabios-$*.bin

lgplvgabios: $(patsubst %,lgplvgabios-%,$(vgabios_variants))

lgplvgabios-%:
	make -C vgabios vgabios-$*.bin
	cp vgabios/VGABIOS-lgpl-latest.$*.bin ../pc-bios/vgabios-$*.bin

=== tests/Makefile ===
export SRC_PATH

check-unit-y = tests/check-qdict$(EXESUF)
check-unit-y += tests/check-qfloat$(EXESUF)
check-unit-y += tests/check-qint$(EXESUF)
check-unit-y += tests/check-qstring$(EXESUF)
check-unit-y += tests/check-qlist$(EXESUF)
check-unit-y += tests/check-qjson$(EXESUF)
check-unit-y += tests/test-qmp-output-visitor$(EXESUF)
check-unit-y += tests/test-qmp-input-visitor$(EXESUF)
check-unit-y += tests/test-qmp-input-strict$(EXESUF)
check-unit-y += tests/test-qmp-commands$(EXESUF)
check-unit-y += tests/test-string-input-visitor$(EXESUF)
check-unit-y += tests/test-string-output-visitor$(EXESUF)
check-unit-y += tests/test-coroutine$(EXESUF)
check-unit-y += tests/test-visitor-serialization$(EXESUF)
check-unit-y += tests/test-iov$(EXESUF)

check-block-$(CONFIG_POSIX) += tests/qemu-iotests-quick.sh

# All QTests for now are POSIX-only, but the dependencies are
# really in libqtest, not in the testcases themselves.
check-qtest-i386-y = tests/fdc-test$(EXESUF)
check-qtest-i386-y += tests/hd-geo-test$(EXESUF)
check-qtest-i386-y += tests/rtc-test$(EXESUF)
check-qtest-x86_64-y = $(check-qtest-i386-y)
check-qtest-sparc-y = tests/m48t59-test$(EXESUF)
check-qtest-sparc64-y = tests/m48t59-test$(EXESUF)

GENERATED_HEADERS += tests/test-qapi-types.h tests/test-qapi-visit.h tests/test-qmp-commands.h

test-obj-y = tests/check-qint.o tests/check-qstring.o tests/check-qdict.o \
	tests/check-qlist.o tests/check-qfloat.o tests/check-qjson.o \
	tests/test-coroutine.o tests/test-string-output-visitor.o \
	tests/test-string-input-visitor.o tests/test-qmp-output-visitor.o \
	tests/test-qmp-input-visitor.o tests/test-qmp-input-strict.o \
	tests/test-qmp-commands.o tests/test-visitor-serialization.o

test-qapi-obj-y =  $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y)
test-qapi-obj-y += tests/test-qapi-visit.o tests/test-qapi-types.o
test-qapi-obj-y += module.o

$(test-obj-y): QEMU_INCLUDES += -Itests

tests/check-qint$(EXESUF): tests/check-qint.o qint.o $(tools-obj-y)
tests/check-qstring$(EXESUF): tests/check-qstring.o qstring.o $(tools-obj-y)
tests/check-qdict$(EXESUF): tests/check-qdict.o qdict.o qfloat.o qint.o qstring.o qbool.o qlist.o $(tools-obj-y)
tests/check-qlist$(EXESUF): tests/check-qlist.o qlist.o qint.o $(tools-obj-y)
tests/check-qfloat$(EXESUF): tests/check-qfloat.o qfloat.o $(tools-obj-y)
tests/check-qjson$(EXESUF): tests/check-qjson.o $(qobject-obj-y) $(tools-obj-y)
tests/test-coroutine$(EXESUF): tests/test-coroutine.o $(coroutine-obj-y) $(tools-obj-y)
tests/test-iov$(EXESUF): tests/test-iov.o iov.o

tests/test-qapi-types.c tests/test-qapi-types.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o tests -p "test-" < $<, "  GEN   $@")
tests/test-qapi-visit.c tests/test-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o tests -p "test-" < $<, "  GEN   $@")
tests/test-qmp-commands.h tests/test-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-commands.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o tests -p "test-" < $<, "  GEN   $@")


tests/test-string-output-visitor$(EXESUF): tests/test-string-output-visitor.o $(test-qapi-obj-y)
tests/test-string-input-visitor$(EXESUF): tests/test-string-input-visitor.o $(test-qapi-obj-y)
tests/test-qmp-output-visitor$(EXESUF): tests/test-qmp-output-visitor.o $(test-qapi-obj-y)
tests/test-qmp-input-visitor$(EXESUF): tests/test-qmp-input-visitor.o $(test-qapi-obj-y)
tests/test-qmp-input-strict$(EXESUF): tests/test-qmp-input-strict.o $(test-qapi-obj-y)
tests/test-qmp-commands$(EXESUF): tests/test-qmp-commands.o tests/test-qmp-marshal.o $(test-qapi-obj-y)
tests/test-visitor-serialization$(EXESUF): tests/test-visitor-serialization.o $(test-qapi-obj-y)

tests/rtc-test$(EXESUF): tests/rtc-test.o $(trace-obj-y)
tests/m48t59-test$(EXESUF): tests/m48t59-test.o $(trace-obj-y)
tests/fdc-test$(EXESUF): tests/fdc-test.o tests/libqtest.o $(trace-obj-y)
tests/hd-geo-test$(EXESUF): tests/hd-geo-test.o tests/libqtest.o $(trace-obj-y)

# QTest rules

TARGETS=$(patsubst %-softmmu,%, $(filter %-softmmu,$(TARGET_DIRS)))
QTEST_TARGETS=$(foreach TARGET,$(TARGETS), $(if $(check-qtest-$(TARGET)-y), $(TARGET),))
check-qtest-$(CONFIG_POSIX)=$(foreach TARGET,$(TARGETS), $(check-qtest-$(TARGET)-y))

qtest-obj-y = tests/libqtest.o $(oslib-obj-y) $(tools-obj-y)
$(check-qtest-y): $(qtest-obj-y)

.PHONY: check-help
check-help:
	@echo "Regression testing targets:"
	@echo
	@echo " make check                Run all tests"
	@echo " make check-qtest-TARGET   Run qtest tests for given target"
	@echo " make check-qtest          Run qtest tests"
	@echo " make check-unit           Run qobject tests"
	@echo " make check-block          Run block tests"
	@echo " make check-report.html    Generates an HTML test report"
	@echo
	@echo "Please note that HTML reports do not regenerate if the unit tests"
	@echo "has not changed."
	@echo
	@echo "The variable SPEED can be set to control the gtester speed setting."
	@echo "Default options are -k and (for make V=1) --verbose; they can be"
	@echo "changed with variable GTESTER_OPTIONS."

SPEED = quick
GTESTER_OPTIONS = -k $(if $(V),--verbose,-q)

# gtester tests, possibly with verbose output

.PHONY: $(patsubst %, check-qtest-%, $(QTEST_TARGETS))
$(patsubst %, check-qtest-%, $(QTEST_TARGETS)): check-qtest-%: $(check-qtest-y)
	$(call quiet-command,QTEST_QEMU_BINARY=$*-softmmu/qemu-system-$* \
		gtester $(GTESTER_OPTIONS) -m=$(SPEED) $(check-qtest-$*-y),"GTESTER $@")

.PHONY: $(patsubst %, check-%, $(check-unit-y))
$(patsubst %, check-%, $(check-unit-y)): check-%: %
	$(call quiet-command,gtester $(GTESTER_OPTIONS) -m=$(SPEED) $*,"GTESTER $*")

# gtester tests with XML output

$(patsubst %, check-report-qtest-%.xml, $(QTEST_TARGETS)): check-report-qtest-%.xml: $(check-qtest-y)
	$(call quiet-command,QTEST_QEMU_BINARY=$*-softmmu/qemu-system-$* \
	  gtester -q $(GTESTER_OPTIONS) -o $@ -m=$(SPEED) $(check-qtest-$*-y),"GTESTER $@")

check-report-unit.xml: $(check-unit-y)
	$(call quiet-command,gtester -q $(GTESTER_OPTIONS) -o $@ -m=$(SPEED) $^, "GTESTER $@")

# Reports and overall runs

check-report.xml: $(patsubst %,check-report-qtest-%.xml, $(QTEST_TARGETS)) check-report-unit.xml
	$(call quiet-command,$(SRC_PATH)/scripts/gtester-cat $^ > $@, "  GEN    $@")

check-report.html: check-report.xml
	$(call quiet-command,gtester-report $< > $@, "  GEN    $@")


# Other tests

.PHONY: check-tests/qemu-iotests-quick.sh
check-tests/qemu-iotests-quick.sh: tests/qemu-iotests-quick.sh qemu-img$(EXESUF) qemu-io$(EXESUF)
	$<

# Consolidated targets

.PHONY: check-qtest check-unit check
check-qtest: $(patsubst %,check-qtest-%, $(QTEST_TARGETS))
check-unit: $(patsubst %,check-%, $(check-unit-y))
check-block: $(patsubst %,check-%, $(check-block-y))
check: check-unit check-qtest

-include $(wildcard tests/*.d)

=== debian/changelog ===
qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.7) quantal-security; urgency=medium

  * SECURITY UPDATE: arbitrary code execution via MAC address table update
    - debian/patches/CVE-2014-0150.patch: fix overflow in hw/virtio-net.c.
    - CVE-2014-0150
  * SECURITY UPDATE: denial of service and possible code execution via
    smart self test counter
    - debian/patches/CVE-2014-2894.patch: correct self-test count in
      hw/ide/core.c.
    - CVE-2014-2894
 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 25 Apr 2014 16:36:17 -0400

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.6) quantal-security; urgency=medium

  * SECURITY UPDATE: privilege escalation via REPORT LUNS
    - debian/patches/CVE-2013-4344.patch: support more than 256 LUNS in
      hw/scsi-bus.c, hw/scsi.h.
    - CVE-2013-4344
  * SECURITY UPDATE: denial of service in qdisk PV disk backend
    - debian/patches/CVE-2013-4375.patch: mark ioreq as mapped before
      unmapping in error case in hw/xen_disk.c.
    - CVE-2013-4375

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 28 Jan 2014 08:31:54 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.5) quantal-proposed; urgency=low

  * debian/control and qemu-kvm.postinst: remove any g:--- acl on /dev/kvm
    (left over from udev-acl).  (LP: #1057024)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 17 Jul 2013 10:23:13 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.4) quantal-proposed; urgency=low

  * qemu-kvm.preinst: add kvm group if not present.  (LP: #1103022)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Fri, 22 Mar 2013 10:14:18 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.3) quantal-proposed; urgency=low

  [ Nikolaus Rath ]
  * fix-usb-passthrough.patch: fix problems with accessing some host
    USB devices (Closes: 683983) (LP: #1033727)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 29 Jan 2013 22:26:54 -0600

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.2) quantal-security; urgency=low

  * SECURITY UPDATE: guest denial of service and possible code execution
    via e1000 large packets
    - debian/patches/CVE-2012-6075.patch: properly discard oversize packets
      in hw/e1000.c.
    - CVE-2012-6075

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 15 Jan 2013 09:22:12 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.1) quantal-proposed; urgency=low

  [ Serge Hallyn ]
  * debian/qemu-kvm.postinst: use udevadm trigger to change /dev/kvm perms as
    recommended by Steve Langasek (LP: #1057024)
  * apply debian/patches/nbd-fixes-to-read-only-handling.patch from upstream to
    make read-write mount after read-only mount work.  (LP: #1077838)
  * make qemu-kvm depend on udev (LP: #1080912)

  [ Robert Collins ]
  * Fix upstart job to succeed if ksm settings can't be altered in the same way
    other settings are handled. (LP: #1078530)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 19 Nov 2012 09:15:42 -0600

qemu-kvm (1.2.0+noroms-0ubuntu2) quantal-proposed; urgency=low

  * debian/rules: drop building of mpc8544ds from pc-bios (as it's no longer
    there) on powerpc to fix FTBFS.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 24 Sep 2012 14:14:27 -0500

qemu-kvm (1.2.0+noroms-0ubuntu1) quantal; urgency=low

  * merge upstream v1.2.0  (LP: #1052932) (LP: #1040033)
    - debian/rules: remove --enable-kvm-device-assignment - configure switch
      no longer supported
    - remaining patches:
      . 02_use_usr_share_kvm_fixed.patch
      . 04_use_etc_kvm_kvm-ifup.patch
      . disable-hpet-for-tcg.patch
      . use-libexecdir.patch
      . ubuntu/larger_default_ram_size.patch
      . ubuntu/fallback-to-tcg.patch - ported to new code
      . ubuntu/dont-try-to-hotplug-cpu.patch
      . ubuntu/expose_vmx_qemu64cpu.patch
      . ubuntu/fix-vmware-vga-negative-vals
      . ubuntu/99-allow-loading-u-boot-initrd-images.patch

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 12 Sep 2012 10:46:28 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu11) quantal; urgency=low

  * Cherrypick three patches from upstream
    - kvm-i8254-fix-conversion-of-in-kernel-to-userspace-state
    - kvm-i8254-cache-kernel-clock-offset-in-KVMPITState
    - kvm-i8254-finish-time-conversion-fix
    to fix time passing too quickly in some guests.  (LP: #1046771)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 06 Sep 2012 10:06:41 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu10) quantal; urgency=low

  * debian/qemu-kvm.modprobe: set nested=1 at module load.  (LP: #1040230)
  * remove patch ubuntu/define_AT_EMPTY_PATH, the real fix is now in eglibc.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 23 Aug 2012 11:10:53 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu9) quantal; urgency=low

  [ Michael Tokarev ]
  * added two patches from upstream qemu-kvm/stable-1.1 branch:
    qemu-kvm-Add-missing-default-machine-options.patch
    qemu-kvm-virtio-Do-not-register-mask-notifiers-witho.patch
    (Closes: #679788) (LP: #1029201)

  [ Serge Hallyn ]
  * remove ubuntu/CVE-2011-2212-virtqueue-indirect-overflow.patch
    patch, which was actually fixed in qemu 0.15 by 
    "virtio: fix indirect descriptor buffer overflow"  (Thanks to
    Michael Tokarev for pointing that out)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 26 Jul 2012 10:31:53 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu8) quantal; urgency=low

  * debian/qemu-kvm.upstart: don't fail if the kernel modules are not
    found.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 11 Jul 2012 17:18:06 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu7) quantal; urgency=low

  * ubuntu/99-ppc-increase-usability-of-ppce500-pci.patch: Allows more than
    2 PCI devices on e500 type systems.
  * Enable ppc64-softmmu target on PowerPC as well

 -- Ben Collins <bcollins@ubuntu.com>  Thu, 28 Jun 2012 21:50:30 -0400

qemu-kvm (1.1~rc+dfsg-1ubuntu6) quantal; urgency=low

  * Add libfdt-dev [powerpc] to build-deps
  * Force --enable-fdt for powerpc builds
  * 99-allow-loading-u-boot-initrd-images.patch: Add capability to load
    initrd's in U-Image format.


=== debian/control ===
Source: qemu-kvm
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael Tokarev <mjt@tls.msk.ru>
Uploaders: Guido Günther <agx@sigxcpu.org>, Jan Lübbe <jluebbe@debian.org>
Build-Depends: debhelper (>= 8), pkg-config, texinfo, python,
 libaio-dev,
 libasound2-dev,
 libattr1-dev,
 libbluetooth-dev,
 libbrlapi-dev,
 libcap-dev,
 libcurl4-gnutls-dev,
 libglib2.0-dev,
 libgnutls-dev,
 libjpeg-dev,
 libncurses5-dev,
 libpci-dev,
 libpulse-dev,
 libpng12-dev,
 librados-dev, librbd-dev,
 libsasl2-dev,
 libsdl1.2-dev,
 linux-libc-dev (>= 2.6.32),
 uuid-dev,
 xfslibs-dev,
 zlib1g-dev,
 device-tree-compiler [powerpc],
 libfdt-dev [powerpc]
Standards-Version: 3.9.3
Homepage: http://www.linux-kvm.org/
Vcs-Browser: http://git.debian.org/?p=collab-maint/qemu-kvm.git
Vcs-Git: git://git.debian.org/git/collab-maint/qemu-kvm.git

Package: qemu-kvm
Architecture: any
Pre-Depends: adduser
Depends: ${shlibs:Depends}, ${misc:Depends}, acl, python,
 seabios (>> 1.7.0~), udev, vgabios (>= 0.6c-3~),
 qemu-utils (>= ${source:Version}), qemu-common (>= ${source:Version})
Recommends: bridge-utils, iproute
Suggests: debootstrap, samba
Provides: kvm, qemu
Conflicts: kvm-source (<= 18-1), kvm-data (<= 66+dfsg-1.1), kvm (<< 1:0)
Breaks: libvirt0 (<< 0.9.8-2~)
Replaces: kvm-data (<= 66+dfsg-1.1), kvm (<< 1:0)
Description: Full virtualization on supported hardware
 Using KVM, one can run multiple virtual systems, each running unmodified Linux
 or Windows images. Each virtual machine has private virtualized hardware: a
 network card, disk, graphics adapter, etc. 
 .
 KVM (for Kernel-based Virtual Machine) is a full virtualization solution for
 Linux hosts on many types of hardware. KVM is intended for systems where
 the processor has hardware support for virtualization, see below for details.
 All combinations of 32-bit and 64-bit host and guest systems are supported,
 except 64-bit guests on 32-bit hosts.
 .
 KVM requires your system to support hardware virtualization, provided by AMD's
 SVM capability or Intel's VT (for x86) or a similar hardware virtualization
 on other hardware (such as SPARC and PowerPC). See
 /usr/share/doc/qemu-kvm/README.Debian for more information.

Package: qemu-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: qemu-kvm (<< 0.15.0+noroms-0ubuntu6)
Replaces: qemu-kvm (<< 0.15.0+noroms-0ubuntu6)
Description: qemu utilities
 This package provides some utilities for which full qemu-kvm is not needed,
 in particular qemu-nbd and qemu-img.

Package: qemu-common
Architecture: all
Depends: bridge-utils, seabios, vgabios (>= 0.6c-2ubuntu2), ${misc:Depends}, ${shlibs:Depends}
Recommends: cpu-checker, kvm-ipxe
Suggests: mol-drivers-macosx,
          openbios-sparc,
          ubuntu-vm-builder,
          uml-utilities
Replaces: qemu-kvm (<< 0.12.3+noroms-0ubuntu1)
Description: qemu common functionality (bios, documentation, etc)
 This package pulls in the various binary bios rom blobs needed to boot
 the various emulated architectures, as well as the documentation.

Package: kvm
Architecture: amd64 armel armhf i386 powerpc sparc
Depends: qemu-kvm, ${misc:Depends}
Section: misc
Description: dummy transitional package from kvm to qemu-kvm
 This transitional package helps users transition from the kvm package to the
 qemu-kvm package.  Once this package and its dependencies are installed you
 can safely remove it.

Package: qemu
Architecture: amd64 armel armhf i386 powerpc sparc
Depends: qemu-kvm, ${misc:Depends}
Section: misc
Description: dummy transitional package from qemu to qemu-kvm
 This transitional package helps users transition from the qemu package to the
 qemu-kvm package.  Once this package and its dependencies are installed you
 can safely remove it.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper. 
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# where all bios and other support files are installed
sharedir := /usr/share
confsuffix := /qemu
bdir := /usr/share/qemu
tdir := debian/qemu-kvm
tbdir := ${tdir}$(bdir)
cdir := debian/qemu-common
udir := debian/qemu-utils

# where various other packages keeps their data files
ipxe := /usr/lib/ipxe
seabios := /usr/share/seabios
vgabios := /usr/share/vgabios

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_CPU   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
BASE_ARCH := $(DEB_BUILD_ARCH)
DEB_VERSION := $(shell sed -n -e 's/^[^(]* (\([^)]*\)) .*/\1/p' -e1q debian/changelog)

export DEB_BUILD_HARDENING=1

# Handle DEB_BUILD_OPTIONS=parallel=N
, := ,
ifneq (,$(filter parallel=%,$(subst $(,), ,$(DEB_BUILD_OPTIONS))))
  NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(subst $(,), ,$(DEB_BUILD_OPTIONS))))
  MAKEFLAGS += -j$(NUMJOBS)
endif

ifeq (i386,$(DEB_BUILD_ARCH))
	BASE_ARCH := x86
endif
ifeq (amd64,$(DEB_BUILD_ARCH))
	BASE_ARCH := x86
endif

ifeq (powerpc,$(BASE_ARCH))
QEMU_TARGET = "ppc-softmmu ppc64-softmmu"
else
QEMU_TARGET = "x86_64-softmmu i386-softmmu x86_64-linux-user i386-linux-user"
endif

CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS += $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS += -Wall
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

ifeq ($(DEB_HOST_ARCH_CPU),arm)
CFLAGS += -fno-var-tracking
endif

#export DH_OPTIONS = --with=quilt --parallel

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep
binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
# "+" in front of dh is to work around dh completely ignoring
# --parallel and DEB_BUILD_OPTIONS=parallel=NN
	+dh $@

# These systems have real KVM support
ifeq ($(filter $(DEB_HOST_ARCH),i386 amd64 lpia powerpc),)
conf_arch += --disable-kvm
else
conf_arch += --enable-kvm
endif

# On PowerPC, we have a couple device tree blobs we need
ifeq (powerpc,$(BASE_ARCH))
conf_arch += --enable-fdt
blobs_arch += bamboo.dts
else
conf_arch += --disable-blobs
endif

override_dh_auto_configure config:
	mkdir -p build/
	cd build && ../configure \
		--with-pkgversion="qemu-kvm-$(DEB_VERSION), Debian" \
		--target-list=$(QEMU_TARGET) \
		--prefix=/usr \
		--with-confsuffix=${confsuffix} \
		--datadir=${sharedir} \
		--sysconfdir=/etc \
		--libexecdir=/usr/lib \
		--extra-cflags="$(CFLAGS)" \
		--extra-ldflags="$(LDFLAGS)" \
		--disable-strip \
		--disable-xen \
		--disable-guest-agent \
		--audio-drv-list="pa,alsa,sdl,oss" \
		--enable-docs \
		--audio-card-list="ac97 es1370 sb16 cs4231a adlib gus hda" \
		`sed 's/#.*//' ../debian/optional-features` \
		$(conf_arch) \
		$(QEMU_KVM_CONFIGURE_OPTIONS) \
	  || { echo == config.log ==; cat config.log; echo == config.log end ==; exit 1; }
	cat build/config-host.mak

override_dh_auto_build:
# main executable and support tools
	$(MAKE) -C build/ ROMS= TOOLS=
ifeq (x86, $(BASE_ARCH))
	$(MAKE) -C build/pc-bios/optionrom
endif

# arch-specific stuff

override_dh_auto_test:

override_dh_auto_clean:
	rm -rf build/
	rm -f scripts/*.pyc
	rm -f scripts/tracetool/*.pyc
	rm -f scripts/tracetool/backend/*.pyc
	rm -f scripts/tracetool/format/*.pyc

override_dh_auto_install:
	$(MAKE) -C build DESTDIR=$(CURDIR)/debian/qemu-kvm install BLOBS="$(blobs_arch)"
ifeq (powerpc,$(BASE_ARCH))
	# Generate the compiled device tree blobs
	dtc -I dts -O dtb -o debian/qemu-kvm$(bdir)/bamboo.dtb \
		debian/qemu-kvm$(bdir)/bamboo.dts
endif
	# dirctory links we use in Ubuntu
	dh_link usr/share/qemu usr/share/qemu-kvm
	dh_link usr/share/qemu usr/share/kvm
	dh_link usr/share/doc/qemu usr/share/doc/kvm
	dh_link etc/qemu etc/kvm
ifeq (powerpc,$(BASE_ARCH))
	dh_link usr/bin/qemu-system-ppc usr/bin/kvm
	dh_link usr/share/man/man1/qemu-kvm.1 usr/share/man/man1/qemu-ppc.1
	dh_link usr/share/man/man1/qemu-kvm.1 usr/share/man/man1/qemu-ppc64.1
	dh_link usr/share/man/man1/qemu.1 usr/share/man/man1/qemu-system-ppc.1
	dh_link usr/share/man/man1/qemu.1 usr/share/man/man1/qemu-system-ppc64.1
else
	dh_link usr/bin/qemu-system-x86_64 usr/bin/kvm
	dh_link usr/share/man/man1/qemu-kvm.1 usr/share/man/man1/qemu-i386.1
	dh_link usr/share/man/man1/qemu-kvm.1 usr/share/man/man1/qemu-x86_64.1
	dh_link usr/share/man/man1/qemu.1 usr/share/man/man1/qemu-system-i386.1
	dh_link usr/share/man/man1/qemu.1 usr/share/man/man1/qemu-system-x86_64.1
endif

# qemu builds only a few files and we will rename them all anyway,
# so install it all here manually.
	install -Dp build/qemu.1 ${tdir}/usr/share/man/man1/kvm.1

	# Install the userspace utilities
	install -m 0755 scripts/kvm/kvm_stat ${tdir}/usr/bin/

	# Move files for Ubuntu's qemu-utils package
	mv ${tdir}/usr/bin/qemu-nbd ${udir}/usr/bin/qemu-nbd
	mv ${tdir}/usr/bin/qemu-img ${udir}/usr/bin/qemu-img
	mv ${tdir}/usr/share/man/man1/qemu-img.1 ${udir}/usr/share/man/man1
	mv ${tdir}/usr/share/man/man8/qemu-nbd.8 ${udir}/usr/share/man/man8

	# copy ifup/down and keymaps to Ubuntu's qemu-common
	install -Dp -m 0755 debian/kvm-ifup ${cdir}/usr/bin/qemu-ifup
	install -Dp -m 0755 debian/kvm-ifdown ${cdir}/usr/bin/qemu-ifdown
	mkdir -p ${cdir}/usr/share/qemu
	mv ${tdir}/usr/share/qemu/keymaps ${cdir}/usr/share/qemu/

ifeq (x86,$(BASE_ARCH))
	# link appropriate bios files from seabios package
	dh_link -pqemu-common \
	  ${seabios}/bios.bin ${bdir}/bios.bin \
	  ${seabios}/optionrom/extboot.bin ${bdir}/extboot.bin \
	  ${seabios}/optionrom/linuxboot.bin ${bdir}/linuxboot.bin \
	  ${seabios}/optionrom/multiboot.bin ${bdir}/multiboot.bin \
	  ${seabios}/optionrom/kvmvapic.bin ${bdir}/kvmvapic.bin \
	  ${seabios}/optionrom/kvmvapic.bin ${bdir}/vapic.bin \

	# link to vgabios files and vgabios.bin too, for now
	dh_link -pqemu-common \
	  ${vgabios}/vgabios.cirrus.bin ${bdir}/vgabios-cirrus.bin \
	  ${vgabios}/vgabios.stdvga.bin ${bdir}/vgabios-stdvga.bin \
	  ${vgabios}/vgabios.vmware.bin ${bdir}/vgabios-vmware.bin \
	  ${vgabios}/vgabios.qxl.bin ${bdir}/vgabios-qxl.bin \
	  ${vgabios}/vgabios.bin ${bdir}/vgabios.bin

# note - we get our ipxe roms from kvm-ipxe

# x86 cpu definitions
	install -Dp -m 0644 \
	  sysconfigs/target/target-x86_64.conf \
	  sysconfigs/target/cpus-x86_64.conf \
	  ${tdir}/etc/kvm/
endif

#ifeq (powerpc,$(BASE_ARCH))
#	cp build/pc-bios/bamboo.dtd ${tbdir}/bamboo.dtd
#endif

override_dh_installinit:
	dh_installinit --no-restart-on-upgrade

override_dh_strip:
	dh_strip -a

debsrc_ver := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p' | perl -pe 's/-[^-]+$$//o')
debian_rev := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p' | perl -pe 's/.*-//o')

override_dh_gencontrol:
	dh_gencontrol -Nkvm
	dh_gencontrol -pkvm -- -v1:84+dfsg-0ubuntu16+$(debsrc_ver)+$(debian_rev)

.PHONY: config
.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_clean override_dh_auto_install override_dh_installinit override_dh_strip override_dh_gencontrol

# get-orig-source adapted from /usr/share/gnome-pkg-tools/1/rules/sf-get-source.mk from the gnome-pkg-tools package
# copied from CDBS' buildvars
